using System.Collections.Generic;
using UnityEngine;
using SimpleJSON;
using System.Collections;
using UnityEngine.Events;
using UnityEngine.UI;

/* 95% written by MeshedVR
Doc'0c adapted it to a plugin
*/
namespace ReVAMped
{

    public class WindControl : MVRScript
    {
        Atom windDirection;
        public static Vector3 globalWind = Vector3.zero;
        protected static Vector3  newDirection = Vector3.zero;
        protected string _missingReceiverStoreId = string.Empty;
        public bool isGlobal;
		public bool isAvatar;
        public bool pushAvatar;
        public bool quicknessRatioToggle;
        public bool periodRatioToggle;
        public bool isTornado;
        public bool isTornadoClock;
        public bool isRadial;
        public bool isRadialIntensity;
        public bool isBlowing;
        public bool isBySpeed;
        public bool isByRotation;
        public bool oscillation=false;
        protected float windRandomX;
        protected float windRandomY;
        protected float windRandomZ;
        protected JSONStorableBool isGlobalJSON;
		protected JSONStorableBool isAvatarJSON;
        protected JSONStorableBool pushAvatarJSON;
        protected JSONStorableBool isTornadoJSON;
        protected JSONStorableBool isTornadoClockJSON;
        protected JSONStorableBool isBlowingJSON;
        protected JSONStorableBool isBySpeedJSON;
        protected JSONStorableBool isByRotationJSON;
        protected Atom receivingAtom;
        protected Atom receivingSlider;
        protected JSONStorableStringChooser atomJSON;
        protected JSONStorableStringChooser receivingSliderJSON;
        protected JSONStorable receiver;
        protected JSONStorableStringChooser receiverJSON;
        protected JSONStorableStringChooser slider_receiverJSON;
        protected string _receiverTargetName;
        protected JSONStorableVector3 receiverTarget;
        protected JSONStorableStringChooser receiverTargetJSON;
        protected JSONStorableFloat topSliderMagnitudeJSON;
        protected JSONStorableFloat currentMagnitudeJSON;
        protected JSONStorableBool randomWindSpeedJSON;
        protected JSONStorableBool oscillatingJSON;
        protected JSONStorableFloat periodJSON;
        protected JSONStorableFloat quicknessJSON;
        protected JSONStorableFloat windDecay;
        protected JSONStorableFloat avatarMobility;
        protected JSONStorableFloat windStrength;
        protected JSONStorableFloat windTurbulence;
        protected JSONStorableFloat speedThreshold;
        protected JSONStorableFloat speedQuickness;
        protected JSONStorableFloat speedMultiplier;
        protected JSONStorableFloat targetMagnitudeJSON;
        protected JSONStorableFloat lowerMagnitudeJSON;
        protected JSONStorableFloat lowerMagnitudeRatioJSON;
        protected JSONStorableFloat quicknessRatioJSON;
        protected JSONStorableFloat periodRatioJSON;
        protected JSONStorableBool quicknessRatioToggleJSON;
        protected JSONStorableBool periodRatioToggleJSON;
        protected JSONStorableFloat oscillationVariance;
        protected JSONStorableFloat upperMagnitudeJSON;
        protected float timer;
        protected Vector3 direction;
        protected Dictionary<string, ForceReceiver> receiverNameToForceReceiver;
        protected Rigidbody RB;
        protected UIDynamicButton btn;
        protected string _lastBrowseDir;

        protected JSONStorableFloat mobility_strong;
        protected JSONStorableFloat mobility_medium;
        protected JSONStorableFloat mobility_light;
        protected JSONStorableFloat mobility_controller;

        protected JSONStorableBool isRadialJSON;
        protected JSONStorableBool isRadialIntensityJSON;

        protected Dictionary<string, bool> RB_enabled;
        protected Dictionary<string, JSONStorableFloat> RB_mobility;
        protected Dictionary<string, FreeControllerV3> Controllers;

        protected float timer2=0;
        protected float speed;
        protected float oldSpeed;

        protected void SyncReceiverRB(string receiver)
        {
            if (receiver != null)
            {
                ForceReceiver fr;
                if (receiverNameToForceReceiver.TryGetValue(receiver, out fr))
                {
                    RB = fr.GetComponent<Rigidbody>();
                }
                else
                {
                    RB = null;
                }
            }
            else
            {
                RB = null;
            }
        }

        protected void initRBdicts()
        {
            RB_enabled = new Dictionary<string, bool>();
            RB_mobility = new Dictionary<string, JSONStorableFloat>();

            mobility_light=new JSONStorableFloat("mobility_light", 1f, 0.1f, 1.0f, true, true);
            mobility_strong=new JSONStorableFloat("mobility_strong", 0.1f, 0.1f, 1.0f, true, true);
            mobility_medium=new JSONStorableFloat("mobility_medium", 0.5f, 0.1f, 1.0f, true, true);
            mobility_controller=new JSONStorableFloat("mobility_controller", 0.1f, 0.1f, 1.0f, true, true);
        }
/*
        protected void SetDefaultControllers()
        {
            Controllers.Add("")
        }
*/
        protected void SetDefaultRBmobility()
        {
            RB_mobility.Add("control",mobility_light);
            RB_mobility.Add("rNipple",mobility_light);
            RB_mobility.Add("lNipple",mobility_light);
            RB_mobility.Add("pelvis",mobility_strong);
            RB_mobility.Add("hip",mobility_strong);
            RB_mobility.Add("rThigh",mobility_light);
            RB_mobility.Add("lThigh",mobility_light);
            RB_mobility.Add("rShin",mobility_light);
            RB_mobility.Add("lShin",mobility_light);
            RB_mobility.Add("rFoot",mobility_controller);
            RB_mobility.Add("lFoot",mobility_controller);
            RB_mobility.Add("LGlute",mobility_medium);
            RB_mobility.Add("RGlute",mobility_medium);
            RB_mobility.Add("abdomen",mobility_strong);
            RB_mobility.Add("abdomen2",mobility_strong);
            RB_mobility.Add("chest",mobility_controller);
            RB_mobility.Add("rCollar",mobility_light);
            RB_mobility.Add("lCollar",mobility_light);
            RB_mobility.Add("rShldr",mobility_light);
            RB_mobility.Add("lShldr",mobility_light);
            RB_mobility.Add("rForeArm",mobility_light);
            RB_mobility.Add("lForeArm",mobility_light);
            RB_mobility.Add("rHand",mobility_controller);
            RB_mobility.Add("lHand",mobility_controller);
            RB_mobility.Add("rPectoral",mobility_medium);
            RB_mobility.Add("lPectoral",mobility_medium);
            RB_mobility.Add("neck",mobility_light);
            RB_mobility.Add("head",mobility_light);
        }

        protected void SetDefaultRBenabled()
        {
            RB_enabled.Add("control",false);
            RB_enabled.Add("rNipple",false);
            RB_enabled.Add("lNipple",false);
            RB_enabled.Add("pelvis",false);
            RB_enabled.Add("hip",false);
            RB_enabled.Add("rThigh",false);
            RB_enabled.Add("lThigh",false);
            RB_enabled.Add("rShin",false);
            RB_enabled.Add("lShin",false);
            RB_enabled.Add("rFoot",false);
            RB_enabled.Add("lFoot",false);
            RB_enabled.Add("LGlute",false);
            RB_enabled.Add("RGlute",false);
            RB_enabled.Add("abdomen",false);
            RB_enabled.Add("abdomen2",false);
            RB_enabled.Add("chest",false);
            RB_enabled.Add("rCollar",false);
            RB_enabled.Add("lCollar",false);
            RB_enabled.Add("rShldr",false);
            RB_enabled.Add("lShldr",false);
            RB_enabled.Add("rForeArm",false);
            RB_enabled.Add("lForeArm",false);
            RB_enabled.Add("rHand",false);
            RB_enabled.Add("lHand",false);
            RB_enabled.Add("rPectoral",false);
            RB_enabled.Add("lPectoral",false);
            RB_enabled.Add("neck",false);
            RB_enabled.Add("head",false);
        }

        protected void RBpreset_disableAll()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=false;
            this.GetBoolJSONParam("lNipple RigidBody").val=false;
            this.GetBoolJSONParam("pelvis RigidBody").val=false;
            this.GetBoolJSONParam("hip RigidBody").val=false;
            this.GetBoolJSONParam("rThigh RigidBody").val=false;
            this.GetBoolJSONParam("lThigh RigidBody").val=false;
            this.GetBoolJSONParam("rShin RigidBody").val=false;
            this.GetBoolJSONParam("lShin RigidBody").val=false;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=false;
            this.GetBoolJSONParam("RGlute RigidBody").val=false;
            this.GetBoolJSONParam("abdomen RigidBody").val=false;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=false;
            this.GetBoolJSONParam("chest RigidBody").val=false;
            this.GetBoolJSONParam("rCollar RigidBody").val=false;
            this.GetBoolJSONParam("lCollar RigidBody").val=false;
            this.GetBoolJSONParam("rShldr RigidBody").val=false;
            this.GetBoolJSONParam("lShldr RigidBody").val=false;
            this.GetBoolJSONParam("rForeArm RigidBody").val=false;
            this.GetBoolJSONParam("lForeArm RigidBody").val=false;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=false;
            this.GetBoolJSONParam("lPectoral RigidBody").val=false;
            this.GetBoolJSONParam("neck RigidBody").val=false;
            this.GetBoolJSONParam("head RigidBody").val=false;
        }

        protected void RBpreset_enableAll()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=true;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=true;
            this.GetBoolJSONParam("lShin RigidBody").val=true;
            this.GetBoolJSONParam("rFoot RigidBody").val=true;
            this.GetBoolJSONParam("lFoot RigidBody").val=true;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=true;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=true;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=true;
            this.GetBoolJSONParam("lCollar RigidBody").val=true;
            this.GetBoolJSONParam("rShldr RigidBody").val=true;
            this.GetBoolJSONParam("lShldr RigidBody").val=true;
            this.GetBoolJSONParam("rForeArm RigidBody").val=true;
            this.GetBoolJSONParam("lForeArm RigidBody").val=true;
            this.GetBoolJSONParam("rHand RigidBody").val=true;
            this.GetBoolJSONParam("lHand RigidBody").val=true;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_enableAll_noHands()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=true;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=true;
            this.GetBoolJSONParam("lShin RigidBody").val=true;
            this.GetBoolJSONParam("rFoot RigidBody").val=true;
            this.GetBoolJSONParam("lFoot RigidBody").val=true;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=true;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=true;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=true;
            this.GetBoolJSONParam("lCollar RigidBody").val=true;
            this.GetBoolJSONParam("rShldr RigidBody").val=true;
            this.GetBoolJSONParam("lShldr RigidBody").val=true;
            this.GetBoolJSONParam("rForeArm RigidBody").val=true;
            this.GetBoolJSONParam("lForeArm RigidBody").val=true;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_enableAll_noFeet()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=true;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=true;
            this.GetBoolJSONParam("lShin RigidBody").val=true;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=true;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=true;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=true;
            this.GetBoolJSONParam("lCollar RigidBody").val=true;
            this.GetBoolJSONParam("rShldr RigidBody").val=true;
            this.GetBoolJSONParam("lShldr RigidBody").val=true;
            this.GetBoolJSONParam("rForeArm RigidBody").val=true;
            this.GetBoolJSONParam("lForeArm RigidBody").val=true;
            this.GetBoolJSONParam("rHand RigidBody").val=true;
            this.GetBoolJSONParam("lHand RigidBody").val=true;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_enableAll_noHandsFeet()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=true;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=true;
            this.GetBoolJSONParam("lThigh RigidBody").val=true;
            this.GetBoolJSONParam("rShin RigidBody").val=true;
            this.GetBoolJSONParam("lShin RigidBody").val=true;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=true;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=true;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=true;
            this.GetBoolJSONParam("lCollar RigidBody").val=true;
            this.GetBoolJSONParam("rShldr RigidBody").val=true;
            this.GetBoolJSONParam("lShldr RigidBody").val=true;
            this.GetBoolJSONParam("rForeArm RigidBody").val=true;
            this.GetBoolJSONParam("lForeArm RigidBody").val=true;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=true;
            this.GetBoolJSONParam("head RigidBody").val=true;
        }

        protected void RBpreset_enableMain()
        {
            this.GetBoolJSONParam("rNipple RigidBody").val=true;
            this.GetBoolJSONParam("lNipple RigidBody").val=true;
            this.GetBoolJSONParam("pelvis RigidBody").val=false;
            this.GetBoolJSONParam("hip RigidBody").val=true;
            this.GetBoolJSONParam("rThigh RigidBody").val=false;
            this.GetBoolJSONParam("lThigh RigidBody").val=false;
            this.GetBoolJSONParam("rShin RigidBody").val=false;
            this.GetBoolJSONParam("lShin RigidBody").val=false;
            this.GetBoolJSONParam("rFoot RigidBody").val=false;
            this.GetBoolJSONParam("lFoot RigidBody").val=false;
            this.GetBoolJSONParam("LGlute RigidBody").val=true;
            this.GetBoolJSONParam("RGlute RigidBody").val=true;
            this.GetBoolJSONParam("abdomen RigidBody").val=false;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=false;
            this.GetBoolJSONParam("chest RigidBody").val=true;
            this.GetBoolJSONParam("rCollar RigidBody").val=false;
            this.GetBoolJSONParam("lCollar RigidBody").val=false;
            this.GetBoolJSONParam("rShldr RigidBody").val=false;
            this.GetBoolJSONParam("lShldr RigidBody").val=false;
            this.GetBoolJSONParam("rForeArm RigidBody").val=false;
            this.GetBoolJSONParam("lForeArm RigidBody").val=false;
            this.GetBoolJSONParam("rHand RigidBody").val=false;
            this.GetBoolJSONParam("lHand RigidBody").val=false;
            this.GetBoolJSONParam("rPectoral RigidBody").val=true;
            this.GetBoolJSONParam("lPectoral RigidBody").val=true;
            this.GetBoolJSONParam("neck RigidBody").val=false;
            this.GetBoolJSONParam("head RigidBody").val=false;
        }

        protected void RBpreset_floatVal()
        {
            this.GetFloatJSONParam("rNipple Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("lNipple Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("pelvis Mobility").val=mobility_strong.val;
            this.GetFloatJSONParam("hip Mobility").val=mobility_strong.val;
            this.GetFloatJSONParam("rThigh Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("lThigh Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("rShin Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("lShin Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("rFoot Mobility").val=mobility_controller.val;
            this.GetFloatJSONParam("lFoot Mobility").val=mobility_controller.val;
            this.GetFloatJSONParam("LGlute Mobility").val=mobility_medium.val;
            this.GetFloatJSONParam("RGlute Mobility").val=mobility_medium.val;
            this.GetFloatJSONParam("abdomen Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("abdomen2 Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("chest Mobility").val=mobility_controller.val;
            this.GetFloatJSONParam("rCollar Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("lCollar Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("rShldr Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("lShldr Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("rForeArm Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("lForeArm Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("rHand Mobility").val=mobility_controller.val;
            this.GetFloatJSONParam("lHand Mobility").val=mobility_controller.val;
            this.GetFloatJSONParam("rPectoral Mobility").val=mobility_medium.val;
            this.GetFloatJSONParam("lPectoral Mobility").val=mobility_medium.val;
            this.GetFloatJSONParam("neck Mobility").val=mobility_light.val;
            this.GetFloatJSONParam("head Mobility").val=mobility_controller.val;
        }

        protected void debug_print_dictionary()
        {
            foreach(KeyValuePair<string,bool> RB_elem in RB_enabled){
                SuperController.LogMessage("updated RB:"+RB_elem.Key+" val:"+RB_enabled[RB_elem.Key]+"");
            }
        }
        
        protected void SyncIsGlobal(bool b)
        {
            if(isGlobal)
            {
                turnWindOff_Clothes();
            }
            isGlobal = b;
        }
		
		protected void SyncIsAvatar(bool b)
        {
            isAvatar = b;
        }

        protected void SyncPushAvatar(bool b)
        {
            pushAvatar = b;
        }

        protected void SyncQuicknessRatioToggle(bool b)
        {
            quicknessRatioToggle = b;
        }

        protected void SyncPeriodRatioToggle(bool b)
        {
            periodRatioToggle = b;
        }

        protected void SyncIsTornado(bool b)
        {
            isTornado = b;
        }

        protected void SyncIsTornadoClock(bool b)
        {
            isTornadoClock = b;
        }

        protected void SyncIsBlowing(bool b)
        {
            isBlowing = b;
        }

        protected void SyncIsBySpeed(bool b)
        {
            isBySpeed = b;
        }

        protected void SyncIsByRotation(bool b)
        {
            isByRotation = b;
        }

        protected void SyncIsRadial(bool b)
        {
            isRadial = b;
        }

        protected void SyncIsRadialIntensity(bool b)
        {
            isRadialIntensity = b;
        }

         //receivingAtom functions
        protected void SyncAtomChoices()
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            foreach (string atomUiD in SuperController.singleton.GetAtomUIDs())
                stringList.Add(atomUiD);
            atomJSON.choices = stringList;
        }

        protected void OnAtomRename(string oldid, string newid)
        {
            SyncAtomChoices();
            if (atomJSON == null || !(receivingAtom != null))
                return;
            atomJSON.valNoCallback = receivingAtom.uid;
        }

        protected void SyncAtom(string atomUID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (atomUID != null)
            {
                receivingAtom = SuperController.singleton.GetAtomByUid(atomUID);
                if (receivingAtom != null)
                {
                    foreach (string storableId in receivingAtom.GetStorableIDs())
                    {
                        stringList.Add(storableId);
                    }
                    receiverNameToForceReceiver = new Dictionary<string, ForceReceiver>();
                    foreach (ForceReceiver fr in receivingAtom.forceReceivers)
                    {
                        receiverNameToForceReceiver.Add(fr.name, fr);
                    }
                }
            }
            else
                receivingAtom = (Atom)null;

            receiverJSON.choices = stringList;
            receiverJSON.val = "None";
        }

        protected void CheckMissingReceiver()
        {
            if (!(_missingReceiverStoreId != string.Empty)
                || !(receivingAtom != null)
                || !(receivingAtom.GetStorableByID(_missingReceiverStoreId) != null))
                return;

            string receiverTargetName = _receiverTargetName;
            SyncReceiver(_missingReceiverStoreId);
            _missingReceiverStoreId = string.Empty;
            insideRestore = true;
            receiverTargetJSON.val = receiverTargetName;
            insideRestore = false;
        }

        protected void SyncReceiver(string receiverID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (receivingAtom != null && receiverID != null)
            {
                receiver = receivingAtom.GetStorableByID(receiverID);
                if (receiver != null)
                {
                    foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                    {
                        stringList.Add(vector3ParamName);
                    }
                }
                else if (receiverID != "None")
                    _missingReceiverStoreId = receiverID;
            }
            else
            {
                receiver = null;
            }

            receiverTargetJSON.choices = stringList;
            receiverTargetJSON.val = "None";
        }

        //receivingSlider functions
        protected void SyncAtomChoices_slider()
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            foreach (string atomUiD in SuperController.singleton.GetAtomUIDs())
            {
                var temp = SuperController.singleton.GetAtomByUid(atomUiD);
                if(temp.type == "UISlider")
                {
                    stringList.Add(atomUiD);
                }   
            }
            receivingSliderJSON.choices = stringList;
        }
        protected void OnAtomRename_slider(string oldid, string newid)
        {
            SyncAtomChoices_slider();
            if (receivingSliderJSON == null || !(receivingSlider != null))
                return;
            receivingSliderJSON.valNoCallback = receivingSlider.uid;
        }

        protected void SyncAtom_slider(string atomUID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (atomUID != null)
            {
                receivingSlider = SuperController.singleton.GetAtomByUid(atomUID);
                if (receivingSlider != null)
                {
                    foreach (string storableId in receivingSlider.GetStorableIDs())
                    {
                        stringList.Add(storableId);
                    }
                }
            }
            else
                receivingSlider = (Atom)null;

            slider_receiverJSON.choices = stringList;
            slider_receiverJSON.val = "None";
        }

        protected void CheckMissingReceiver_slider()
        {
            if (!(_missingReceiverStoreId != string.Empty)
                || !(receivingSlider != null)
                || !(receivingSlider.GetStorableByID(_missingReceiverStoreId) != null))
                return;

            string receiverTargetName = _receiverTargetName;
            SyncReceiver(_missingReceiverStoreId);
            _missingReceiverStoreId = string.Empty;
            insideRestore = true;
            receiverTargetJSON.val = receiverTargetName;
            insideRestore = false;
        }

        protected void SyncReceiver_slider(string receiverID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (receivingSlider != null && receiverID != null)
            {
                receiver = receivingSlider.GetStorableByID(receiverID);
                if (receiver != null)
                {
                    foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                    {
                        stringList.Add(vector3ParamName);
                    }
                }
                else if (receiverID != "None")
                    _missingReceiverStoreId = receiverID;
            }
            else
            {
                receiver = null;
            }

            receiverTargetJSON.choices = stringList;
            receiverTargetJSON.val = "None";
        }

        protected void SyncReceiverTarget(string receiverTargetName)
        {
            _receiverTargetName = receiverTargetName;
            receiverTarget = (JSONStorableVector3)null;
            if (receiver != null && receiverTargetName != null)
                receiverTarget = receiver.GetVector3JSONParam(receiverTargetName);
        }

        public UIDynamicTextField CreateTextInput(JSONStorableString jss, bool rightSide = false)
        {
            var textfield = CreateTextField(jss, rightSide);
            textfield.height = 1f;
            //textfield.backgroundColor = Color.white;
            var input = textfield.gameObject.AddComponent<InputField>();
            var rect = input.GetComponent<RectTransform>().sizeDelta = new Vector2(1f, 0.4f);
            input.textComponent = textfield.UItext;
            jss.inputField = input;
            return textfield;
        }

        public void SavePreset(string aPath)
        {
            if (System.String.IsNullOrEmpty(aPath))
            {
                return;
            }
            _lastBrowseDir = aPath.Substring(0, aPath.LastIndexOfAny(new char[] { '/', '\\' })) + @"\";

            if (!aPath.ToLower().EndsWith("WindControl".ToLower()))
            {
                aPath += "." + "WindControl";
            }
            JSONClass saveJson = new JSONClass();
            saveJson["savedBy"] = "WindControl";

            saveJson["rNippleFloat"] = this.GetFloatJSONParam("rNipple Mobility").val.ToString();
            saveJson["lNippleFloat"] = this.GetFloatJSONParam("lNipple Mobility").val.ToString();
            saveJson["pelvisFloat"] = this.GetFloatJSONParam("pelvis Mobility").val.ToString();
            saveJson["hipFloat"] = this.GetFloatJSONParam("hip Mobility").val.ToString();
            saveJson["rThighFloat"] = this.GetFloatJSONParam("rThigh Mobility").val.ToString();
            saveJson["lThighFloat"] = this.GetFloatJSONParam("lThigh Mobility").val.ToString();
            saveJson["rShinFloat"] = this.GetFloatJSONParam("rShin Mobility").val.ToString();
            saveJson["lShinFloat"] = this.GetFloatJSONParam("lShin Mobility").val.ToString();
            saveJson["rFootFloat"] = this.GetFloatJSONParam("rFoot Mobility").val.ToString();
            saveJson["lFootFloat"] = this.GetFloatJSONParam("lFoot Mobility").val.ToString();
            saveJson["LGluteFloat"] = this.GetFloatJSONParam("LGlute Mobility").val.ToString();
            saveJson["RGluteFloat"] = this.GetFloatJSONParam("RGlute Mobility").val.ToString();
            saveJson["abdomenFloat"] = this.GetFloatJSONParam("abdomen Mobility").val.ToString();
            saveJson["abdomen2Float"] = this.GetFloatJSONParam("abdomen2 Mobility").val.ToString();
            saveJson["chestFloat"] = this.GetFloatJSONParam("chest Mobility").val.ToString();
            saveJson["rCollarFloat"] = this.GetFloatJSONParam("rCollar Mobility").val.ToString();
            saveJson["lCollarFloat"] = this.GetFloatJSONParam("lCollar Mobility").val.ToString();
            saveJson["rShldrFloat"] = this.GetFloatJSONParam("rShldr Mobility").val.ToString();
            saveJson["lShldrFloat"] = this.GetFloatJSONParam("lShldr Mobility").val.ToString();
            saveJson["rForeArmFloat"] = this.GetFloatJSONParam("rForeArm Mobility").val.ToString();
            saveJson["lForeArmFloat"] = this.GetFloatJSONParam("lForeArm Mobility").val.ToString();
            saveJson["rHandFloat"] = this.GetFloatJSONParam("rHand Mobility").val.ToString();
            saveJson["lHandFloat"] = this.GetFloatJSONParam("lHand Mobility").val.ToString();
            saveJson["rPectoralFloat"] = this.GetFloatJSONParam("rPectoral Mobility").val.ToString();
            saveJson["lPectoralFloat"] = this.GetFloatJSONParam("lPectoral Mobility").val.ToString();
            saveJson["neckFloat"] = this.GetFloatJSONParam("neck Mobility").val.ToString();
            saveJson["headFloat"] = this.GetFloatJSONParam("head Mobility").val.ToString();

            saveJson["rNippleIsEnabled"] = this.GetBoolJSONParam("rNipple RigidBody").val.ToString();
            saveJson["lNippleIsEnabled"] = this.GetBoolJSONParam("lNipple RigidBody").val.ToString();
            saveJson["pelvisIsEnabled"] = this.GetBoolJSONParam("pelvis RigidBody").val.ToString();
            saveJson["hipIsEnabled"] = this.GetBoolJSONParam("hip RigidBody").val.ToString();
            saveJson["rThighIsEnabled"] = this.GetBoolJSONParam("rThigh RigidBody").val.ToString();
            saveJson["lThighIsEnabled"] = this.GetBoolJSONParam("lThigh RigidBody").val.ToString();
            saveJson["rShinIsEnabled"] = this.GetBoolJSONParam("rShin RigidBody").val.ToString();
            saveJson["lShinIsEnabled"] = this.GetBoolJSONParam("lShin RigidBody").val.ToString();
            saveJson["rFootIsEnabled"] = this.GetBoolJSONParam("rFoot RigidBody").val.ToString();
            saveJson["lFootIsEnabled"] = this.GetBoolJSONParam("lFoot RigidBody").val.ToString();
            saveJson["LGluteIsEnabled"] = this.GetBoolJSONParam("LGlute RigidBody").val.ToString();
            saveJson["RGluteIsEnabled"] = this.GetBoolJSONParam("RGlute RigidBody").val.ToString();
            saveJson["abdomenIsEnabled"] = this.GetBoolJSONParam("abdomen RigidBody").val.ToString();
            saveJson["abdomen2IsEnabled"] = this.GetBoolJSONParam("abdomen2 RigidBody").val.ToString();
            saveJson["chestIsEnabled"] = this.GetBoolJSONParam("chest RigidBody").val.ToString();
            saveJson["rCollarIsEnabled"] = this.GetBoolJSONParam("rCollar RigidBody").val.ToString();
            saveJson["lCollarIsEnabled"] = this.GetBoolJSONParam("lCollar RigidBody").val.ToString();
            saveJson["rShldrIsEnabled"] = this.GetBoolJSONParam("rShldr RigidBody").val.ToString();
            saveJson["lShldrIsEnabled"] = this.GetBoolJSONParam("lShldr RigidBody").val.ToString();
            saveJson["rForeArmIsEnabled"] = this.GetBoolJSONParam("rForeArm RigidBody").val.ToString();
            saveJson["lForeArmIsEnabled"] = this.GetBoolJSONParam("lForeArm RigidBody").val.ToString();
            saveJson["rHandIsEnabled"] = this.GetBoolJSONParam("rHand RigidBody").val.ToString();
            saveJson["lHandIsEnabled"] = this.GetBoolJSONParam("lHand RigidBody").val.ToString();
            saveJson["rPectoralIsEnabled"] = this.GetBoolJSONParam("rPectoral RigidBody").val.ToString();
            saveJson["lPectoralIsEnabled"] = this.GetBoolJSONParam("lPectoral RigidBody").val.ToString();
            saveJson["neckIsEnabled"] = this.GetBoolJSONParam("neck RigidBody").val.ToString();
            saveJson["headIsEnabled"] = this.GetBoolJSONParam("head RigidBody").val.ToString();

            this.SaveJSON(saveJson, aPath);
        }

        void LoadPreset(string aPath)
        {
            if (System.String.IsNullOrEmpty(aPath))
            {
                return;
            }
            _lastBrowseDir = aPath.Substring(0, aPath.LastIndexOfAny(new char[] { '/', '\\' })) + @"\";
            var aJson = this.LoadJSON(aPath);

            this.GetBoolJSONParam("rNipple RigidBody").val=aJson["rNippleIsEnabled"].AsBool;
            this.GetBoolJSONParam("lNipple RigidBody").val=aJson["lNippleIsEnabled"].AsBool;
            this.GetBoolJSONParam("pelvis RigidBody").val=aJson["pelvisIsEnabled"].AsBool;
            this.GetBoolJSONParam("hip RigidBody").val=aJson["hipIsEnabled"].AsBool;
            this.GetBoolJSONParam("rThigh RigidBody").val=aJson["rThighIsEnabled"].AsBool;
            this.GetBoolJSONParam("lThigh RigidBody").val=aJson["lThighIsEnabled"].AsBool;
            this.GetBoolJSONParam("rShin RigidBody").val=aJson["rShinIsEnabled"].AsBool;
            this.GetBoolJSONParam("lShin RigidBody").val=aJson["lShinIsEnabled"].AsBool;
            this.GetBoolJSONParam("rFoot RigidBody").val=aJson["rFootIsEnabled"].AsBool;
            this.GetBoolJSONParam("lFoot RigidBody").val=aJson["lFootIsEnabled"].AsBool;
            this.GetBoolJSONParam("LGlute RigidBody").val=aJson["LGluteIsEnabled"].AsBool;
            this.GetBoolJSONParam("RGlute RigidBody").val=aJson["RGluteIsEnabled"].AsBool;
            this.GetBoolJSONParam("abdomen RigidBody").val=aJson["abdomenIsEnabled"].AsBool;
            this.GetBoolJSONParam("abdomen2 RigidBody").val=aJson["abdomen2IsEnabled"].AsBool;
            this.GetBoolJSONParam("chest RigidBody").val=aJson["chestIsEnabled"].AsBool;
            this.GetBoolJSONParam("rCollar RigidBody").val=aJson["rCollarIsEnabled"].AsBool;
            this.GetBoolJSONParam("lCollar RigidBody").val=aJson["lCollarIsEnabled"].AsBool;
            this.GetBoolJSONParam("rShldr RigidBody").val=aJson["rShldrIsEnabled"].AsBool;
            this.GetBoolJSONParam("lShldr RigidBody").val=aJson["lShldrIsEnabled"].AsBool;
            this.GetBoolJSONParam("rForeArm RigidBody").val=aJson["rForeArmIsEnabled"].AsBool;
            this.GetBoolJSONParam("lForeArm RigidBody").val=aJson["lForeArmIsEnabled"].AsBool;
            this.GetBoolJSONParam("rHand RigidBody").val=aJson["rHandIsEnabled"].AsBool;
            this.GetBoolJSONParam("lHand RigidBody").val=aJson["lHandIsEnabled"].AsBool;
            this.GetBoolJSONParam("rPectoral RigidBody").val=aJson["rPectoralIsEnabled"].AsBool;
            this.GetBoolJSONParam("lPectoral RigidBody").val=aJson["lPectoralIsEnabled"].AsBool;
            this.GetBoolJSONParam("neck RigidBody").val=aJson["neckIsEnabled"].AsBool;
            this.GetBoolJSONParam("head RigidBody").val=aJson["headIsEnabled"].AsBool;

            this.GetFloatJSONParam("rNipple Mobility").val=aJson["rNippleFloat"].AsFloat;
            this.GetFloatJSONParam("lNipple Mobility").val=aJson["lNippleFloat"].AsFloat;
            this.GetFloatJSONParam("pelvis Mobility").val=aJson["pelvisFloat"].AsFloat;
            this.GetFloatJSONParam("hip Mobility").val=aJson["hipFloat"].AsFloat;
            this.GetFloatJSONParam("rThigh Mobility").val=aJson["rThighFloat"].AsFloat;
            this.GetFloatJSONParam("lThigh Mobility").val=aJson["lThighFloat"].AsFloat;
            this.GetFloatJSONParam("rShin Mobility").val=aJson["rShinFloat"].AsFloat;
            this.GetFloatJSONParam("lShin Mobility").val=aJson["lShinFloat"].AsFloat;
            this.GetFloatJSONParam("rFoot Mobility").val=aJson["rFootFloat"].AsFloat;
            this.GetFloatJSONParam("lFoot Mobility").val=aJson["lFootFloat"].AsFloat;
            this.GetFloatJSONParam("LGlute Mobility").val=aJson["LGluteFloat"].AsFloat;
            this.GetFloatJSONParam("RGlute Mobility").val=aJson["RGluteFloat"].AsFloat;
            this.GetFloatJSONParam("abdomen Mobility").val=aJson["abdomenFloat"].AsFloat;
            this.GetFloatJSONParam("abdomen2 Mobility").val=aJson["abdomen2Float"].AsFloat;
            this.GetFloatJSONParam("chest Mobility").val=aJson["chestFloat"].AsFloat;
            this.GetFloatJSONParam("rCollar Mobility").val=aJson["rCollarFloat"].AsFloat;
            this.GetFloatJSONParam("lCollar Mobility").val=aJson["lCollarFloat"].AsFloat;
            this.GetFloatJSONParam("rShldr Mobility").val=aJson["rShldrFloat"].AsFloat;
            this.GetFloatJSONParam("lShldr Mobility").val=aJson["lShldrFloat"].AsFloat;
            this.GetFloatJSONParam("rForeArm Mobility").val=aJson["rForeArmFloat"].AsFloat;
            this.GetFloatJSONParam("lForeArm Mobility").val=aJson["lForeArmFloat"].AsFloat;
            this.GetFloatJSONParam("rHand Mobility").val=aJson["rHandFloat"].AsFloat;
            this.GetFloatJSONParam("lHand Mobility").val=aJson["lHandFloat"].AsFloat;
            this.GetFloatJSONParam("rPectoral Mobility").val=aJson["rPectoralFloat"].AsFloat;
            this.GetFloatJSONParam("lPectoral Mobility").val=aJson["lPectoralFloat"].AsFloat;
            this.GetFloatJSONParam("neck Mobility").val=aJson["neckFloat"].AsFloat;
            this.GetFloatJSONParam("head Mobility").val=aJson["headFloat"].AsFloat;
        }

        public override void Init()
        {
            try
            {
                initRBdicts();
                SetDefaultRBmobility();
                SetDefaultRBenabled();

                if ((bool)(SuperController.singleton))
                    SuperController.singleton.onAtomUIDRenameHandlers += new SuperController.OnAtomUIDRename(OnAtomRename);

                
                isGlobalJSON = new JSONStorableBool("Affect Cloth/Hair", false, new JSONStorableBool.SetBoolCallback(SyncIsGlobal));
				isAvatarJSON = new JSONStorableBool("Affect Avatar", false, new JSONStorableBool.SetBoolCallback(SyncIsAvatar));
                pushAvatarJSON = new JSONStorableBool("Wind Pushes Avatar", false, new JSONStorableBool.SetBoolCallback(SyncPushAvatar));
                isTornadoJSON = new JSONStorableBool("Tornado Effect", false, new JSONStorableBool.SetBoolCallback(SyncIsTornado));
                isTornadoClockJSON = new JSONStorableBool("Tornado Wind Direction", false, new JSONStorableBool.SetBoolCallback(SyncIsTornadoClock));

                //receivingAtom stringChooser
                atomJSON = new JSONStorableStringChooser(
                  "atom", SuperController.singleton.GetAtomUIDs(), (string)null,
                  "Atom", new JSONStorableStringChooser.SetStringCallback(SyncAtom));

                atomJSON.popupOpenCallback = new JSONStorableStringChooser.PopupOpenCallback(SyncAtomChoices);
                receiverJSON = new JSONStorableStringChooser(
                  "receiver", (List<string>)null, (string)null,
                  "Receiver", new JSONStorableStringChooser.SetStringCallback(SyncReceiver));

                receiverTargetJSON = new JSONStorableStringChooser(
                  "receiverTarget", (List<string>)null, (string)null,
                  "Target", new JSONStorableStringChooser.SetStringCallback(SyncReceiverTarget));

                //receivingSlider StringChooser
                receivingSliderJSON = new JSONStorableStringChooser(
                  "slider", SuperController.singleton.GetAtomUIDs(), (string)null,
                  "Slider", new JSONStorableStringChooser.SetStringCallback(SyncAtom_slider));

                receivingSliderJSON.popupOpenCallback = new JSONStorableStringChooser.PopupOpenCallback(SyncAtomChoices_slider);
                slider_receiverJSON = new JSONStorableStringChooser(
                  "receivingSlider", (List<string>)null, (string)null,
                  "ReceivingSlider", new JSONStorableStringChooser.SetStringCallback(SyncReceiver_slider));

                topSliderMagnitudeJSON = new JSONStorableFloat("Top Slider Magnitude", 250f, 0f, 300f, false, true);
                currentMagnitudeJSON = new JSONStorableFloat("Current Magnitude (view)", 0.0f, -50f, 50f, false, true);
                randomWindSpeedJSON = new JSONStorableBool("Randomize Current Magnitude", false);
                oscillatingJSON = new JSONStorableBool("Oscillate Current Magnitude", false);
                periodRatioToggleJSON = new JSONStorableBool("Auto Period", false, new JSONStorableBool.SetBoolCallback(SyncPeriodRatioToggle));
                periodJSON = new JSONStorableFloat("Period Length", 0.03f, 0.0f, 1f, false, true);
                periodRatioJSON = new JSONStorableFloat("Period Coeff", 1f, 0f, 4f, false, true);
                quicknessJSON = new JSONStorableFloat("Quickness (view)", 30f, 0.0f, 240f, false, true);
                lowerMagnitudeJSON = new JSONStorableFloat("Lower Magnitude (view)", -50f, -50f, 200f, false, true);
                lowerMagnitudeRatioJSON = new JSONStorableFloat("Lower Magnitude Coeff", -0.25f, -1f, 1f, true, true);
                quicknessRatioToggleJSON = new JSONStorableBool("Auto Quickness", false, new JSONStorableBool.SetBoolCallback(SyncQuicknessRatioToggle));
                quicknessRatioJSON = new JSONStorableFloat("Quickness Coeff", 2f, 0f, 4f, false, true);
                upperMagnitudeJSON = new JSONStorableFloat("upperMagnitude", 150f, -50f, 150f, false, true);
                targetMagnitudeJSON = new JSONStorableFloat("targetMagnitude", 0.0f, -50f, 50f, false, false);
                
                avatarMobility = new JSONStorableFloat("Avatar Mobility", 2f, 0.5f, 10f, true, true);
                windStrength = new JSONStorableFloat("Wind Strength", 0f, 0.0f, 300f, false, true);
                windTurbulence = new JSONStorableFloat("Wind dir Turbulence", 0.5f, 0.0f, 1.0f, false, true);
                oscillationVariance = new JSONStorableFloat("Oscillation Variance", 1.5f, 1f, 100f, true, true);

                speedThreshold = new JSONStorableFloat("Velocity Threshold", 1f, 0.0f, 10f, false, true);
                speedMultiplier = new JSONStorableFloat("Velocity Multiplier", 10f, 0.0f, 10f, false, true);
                speedQuickness = new JSONStorableFloat("Interpolation rate", 10f, 0.0f, 10f, false, true);

                //RIGIDBODIES
                foreach(KeyValuePair<string,bool> RB_elem in RB_enabled)
                {
                    //Now you can access the key and value both separately from this attachStat as:
                    //SuperController.LogMessage("RB:"+RB_elem.Key+" val:"+RB_elem.Value+"");
                    var tempRB_enab = new JSONStorableBool(RB_elem.Key+" RigidBody", RB_elem.Value,(bool enabled)=>
                    {
                        RB_enabled[RB_elem.Key]=enabled;
                        //SuperController.LogMessage("updated RB:"+RB_elem.Key+" val:"+RB_enabled[RB_elem.Key]+"");
                    });
                    RegisterBool(tempRB_enab);
                    //SuperController.LogMessage("RB:"+tempRB_enab.val+" val:"+RB_elem.Value+"");
                    CreateToggle(tempRB_enab,true);
                    var temp_mobility=RB_mobility[RB_elem.Key].val;
                    RB_mobility[RB_elem.Key] = new JSONStorableFloat(RB_elem.Key+" Mobility", temp_mobility, 0.1f, 1.0f, false, true);
                    RegisterFloat(RB_mobility[RB_elem.Key]);   
                    CreateSlider(RB_mobility[RB_elem.Key],true);
                }
                RBpreset_enableMain();
                RegisterStringChooser(atomJSON);
                CreateScrollablePopup(atomJSON, false);
                RegisterStringChooser(receivingSliderJSON);
                CreateScrollablePopup(receivingSliderJSON, false);

                isRadialJSON = new JSONStorableBool("Radial Wind", false, (bool b)=>{SyncIsRadial(b); });
                isRadialIntensityJSON = new JSONStorableBool("Radial Wind Decay", false, (bool b)=>{SyncIsRadialIntensity(b); });
                isBlowingJSON = new JSONStorableBool("Suck/Blow", false, new JSONStorableBool.SetBoolCallback(SyncIsBlowing));
                isBySpeedJSON = new JSONStorableBool("Velocity = Wind Stength", false, new JSONStorableBool.SetBoolCallback(SyncIsBySpeed));
                isByRotationJSON = new JSONStorableBool("Speed/Rotation", false, new JSONStorableBool.SetBoolCallback(SyncIsByRotation));
                windDecay = new JSONStorableFloat("Wind Decay", 5f, 0f, 10f, false, true);
                


				RegisterBool(isAvatarJSON);
                RegisterBool(pushAvatarJSON);
                RegisterBool(isGlobalJSON);
                

                RegisterBool(randomWindSpeedJSON);
                RegisterBool(oscillatingJSON);
                RegisterFloat(periodJSON);
                //RegisterFloat(periodRatioJSON);
                RegisterBool(quicknessRatioToggleJSON);
                RegisterBool(periodRatioToggleJSON);
                RegisterFloat(quicknessJSON);
                RegisterFloat(upperMagnitudeJSON);
                RegisterFloat(lowerMagnitudeJSON);
                RegisterFloat(lowerMagnitudeRatioJSON);
                RegisterFloat(quicknessRatioJSON);
                RegisterFloat(topSliderMagnitudeJSON);
                RegisterFloat(currentMagnitudeJSON);
                RegisterFloat(windStrength);
                RegisterFloat(windTurbulence);
                RegisterFloat(avatarMobility);
                RegisterFloat(oscillationVariance);

                
                CreateToggle(isAvatarJSON);
                CreateToggle(pushAvatarJSON);
                CreateToggle(isGlobalJSON);
                CreateToggle(randomWindSpeedJSON);
                CreateToggle(oscillatingJSON);
                CreateSlider(windStrength);
                CreateSlider(topSliderMagnitudeJSON);
                CreateSlider(currentMagnitudeJSON);
                 
                CreateSlider(lowerMagnitudeRatioJSON);
                CreateSlider(lowerMagnitudeJSON);
                CreateToggle(quicknessRatioToggleJSON);
                CreateSlider(quicknessRatioJSON);
                CreateSlider(quicknessJSON);
                //CreateSlider(periodRatioJSON);
                CreateToggle(periodRatioToggleJSON);
                CreateSlider(periodJSON);
                CreateSlider(oscillationVariance);
                
                CreateSlider(windTurbulence);
                CreateSlider(avatarMobility);

                RegisterBool(isRadialJSON);
                var tmpToggle = CreateToggle(isRadialJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);              

                tmpToggle = CreateToggle(isBlowingJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                RegisterBool(isBlowingJSON);

                tmpToggle = CreateToggle(isTornadoJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                RegisterBool(isTornadoJSON);

                tmpToggle = CreateToggle(isTornadoClockJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                RegisterBool(isTornadoClockJSON);

                tmpToggle = CreateToggle(isRadialIntensityJSON);
                color_toggle(tmpToggle,Color.white,Color.grey);
                RegisterBool(isRadialIntensityJSON);

                var tmpSlider = CreateSlider(windDecay);
                color_slider(tmpSlider, Color.white, Color.grey);
                RegisterFloat(windDecay);

                tmpToggle = CreateToggle(isBySpeedJSON);
                color_toggle(tmpToggle,Color.black,Color.yellow);
                RegisterBool(isBySpeedJSON);
                tmpToggle = CreateToggle(isByRotationJSON);
                color_toggle(tmpToggle,Color.black,Color.yellow);
                RegisterBool(isByRotationJSON);
                RegisterFloat(speedThreshold);
                tmpSlider = CreateSlider(speedThreshold);
                color_slider(tmpSlider,Color.black, Color.yellow);
                RegisterFloat(speedMultiplier);
                tmpSlider = CreateSlider(speedMultiplier);
                color_slider(tmpSlider,Color.black, Color.yellow);
                RegisterFloat(speedQuickness);
                tmpSlider = CreateSlider(speedQuickness);
                color_slider(tmpSlider,Color.black, Color.yellow);

                //CreateTextInput(new JSONStorableString("info","COLLIDERS PRESETS"), false);
                var enable_main_btn = CreateButton("Enable Main Colliders", false);
                color_btn(enable_main_btn,Color.black,Color.green);
                enable_main_btn.button.onClick.AddListener(RBpreset_enableMain);
                JSONStorableAction enable_main_colliders_action = new JSONStorableAction("Enable Main Colliders", () => {RBpreset_enableMain();});
                RegisterAction(enable_main_colliders_action);

                var disable_all_btn = CreateButton("Disable all Colliders", false);
                color_btn(disable_all_btn,Color.black,Color.green);
                disable_all_btn.button.onClick.AddListener(RBpreset_disableAll);
                JSONStorableAction disable_all_colliders_action = new JSONStorableAction("Disable All Colliders", () => {RBpreset_disableAll();});
                RegisterAction(disable_all_colliders_action);

                var enable_all_btn = CreateButton("Enable all Colliders", false);
                color_btn(enable_all_btn,Color.black,Color.green);
                enable_all_btn.button.onClick.AddListener(RBpreset_enableAll);
                JSONStorableAction enable_all_colliders_action = new JSONStorableAction("Enable All Colliders", () => {RBpreset_enableAll();});
                RegisterAction(enable_all_colliders_action);

                var enable_all_btn_noHands = CreateButton("Enab all except hands", false);
                color_btn(enable_all_btn_noHands,Color.black,Color.green);
                enable_all_btn_noHands.button.onClick.AddListener(RBpreset_enableAll_noHands);
                JSONStorableAction enable_all_colliders_action_noHands = new JSONStorableAction("Enable All Colliders without Hands", () => {RBpreset_enableAll_noHands();});
                RegisterAction(enable_all_colliders_action_noHands);

                var enable_all_btn_noFeet = CreateButton("Enab all except feet", false);
                color_btn(enable_all_btn_noFeet,Color.black,Color.green);
                enable_all_btn_noFeet.button.onClick.AddListener(RBpreset_enableAll_noFeet);
                JSONStorableAction enable_all_colliders_action_noFeet = new JSONStorableAction("Enable All Colliders without Feet", () => {RBpreset_enableAll_noFeet();});
                RegisterAction(enable_all_colliders_action_noFeet);

                var enable_all_btn_noHandsFeet = CreateButton("Enab all except hands/feet", false);
                color_btn(enable_all_btn_noHandsFeet,Color.black,Color.green);
                enable_all_btn_noHandsFeet.button.onClick.AddListener(RBpreset_enableAll_noHandsFeet);
                JSONStorableAction enable_all_colliders_action_noHandsFeet = new JSONStorableAction("Enable All Colliders without Hands and Feet", () => {RBpreset_enableAll_noHandsFeet();});
                RegisterAction(enable_all_colliders_action_noHandsFeet);

                var reset_all_float_btn = CreateButton("Reset all Colliders Values", false);
                color_btn(reset_all_float_btn,Color.black,Color.green);
                reset_all_float_btn.button.onClick.AddListener(RBpreset_floatVal);
                JSONStorableAction reset_all_colliders_float_action = new JSONStorableAction("Reset All Colliders Values", () => {RBpreset_floatVal();});
                RegisterAction(reset_all_colliders_float_action);

                btn = CreateButton("Save Colliders Preset");
                color_btn(btn,Color.white,Color.blue);
                btn.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.NormalizeMediaPath(_lastBrowseDir);
                    SuperController.singleton.GetMediaPathDialog(SavePreset, "WindControl");

                uFileBrowser.FileBrowser browser = SuperController.singleton.mediaFileBrowserUI;
                    browser.SetTextEntry(true);
                    browser.fileEntryField.text = System.String.Format("{0}.{1}", ((int)(System.DateTime.UtcNow - new System.DateTime(1970, 1, 1)).TotalSeconds).ToString(), "WindControl");
                    browser.ActivateFileNameField();
                });

                btn = CreateButton("Load Colliders Preset");
                color_btn(btn,Color.white,Color.blue);
                btn.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.NormalizeMediaPath(_lastBrowseDir);
                    SuperController.singleton.GetMediaPathDialog(LoadPreset, "WindControl");
                });

            }
            catch (System.Exception e)
            {
                SuperController.LogError("" + e);
            }
        }

        protected void OnDisable() //Disable Wind on clothes when the plugin is disabled
        {
            turnWindOff_Clothes();
        }

        protected void OnEnable() //Disable Wind on clothes when the plugin is disabled
        {
            turnWindOff_Clothes();
        }

        protected void Update()
        {
            //Setting up parameters
            lowerMagnitudeJSON.val=windStrength.val*lowerMagnitudeRatioJSON.val;
            upperMagnitudeJSON.val=windStrength.val;
            quicknessJSON.val=0.1f+quicknessRatioJSON.val*windStrength.val/5;
            if(quicknessRatioToggle)
            {
                quicknessJSON.val=windStrength.val/5;
            }
            if(periodRatioToggle)
            {
                periodJSON.val=0.2f-(windStrength.val/1000);
            }
            var WindController=containingAtom.GetStorableByID("control").transform;

            //Set Wind Direction
            var personDirection=receivingAtom.GetStorableByID("chestControl").transform.position - (new Vector3(WindController.position.x, WindController.position.y, WindController.position.z));
            if(isRadial)
            {
                if(isBlowing)
                {
                    newDirection=personDirection;
                }
                else
                {
                    newDirection=-personDirection;
                }
            }
            else if(isTornado)
            {
                var tornadoDistance=personDirection.magnitude*personDirection.magnitude/100;
                var distanceValue=Mathf.Lerp(2f,-2f,tornadoDistance*windDecay.val*2);
                if(isTornadoClock)
                {
                    newDirection=new Vector3(personDirection.z, -personDirection.y,-personDirection.x+distanceValue);
                }
                else
                {
                    newDirection=new Vector3(-personDirection.z, -personDirection.y,personDirection.x+distanceValue);
                }
            }
            else
            {
                newDirection=WindController.transform.forward;
            }

            //Set wind Speed
            if(isBySpeed||isByRotation)
            {
                strengthByVelocity();
            }

            if (randomWindSpeedJSON != null && randomWindSpeedJSON.val)
            {
                
                if(windStrength.val<0.1f)
                {
                    currentMagnitudeJSON.val=0;
                }
                else
                {
                    timer -= Time.deltaTime;
                    if ((double)timer < 0.0)
                    {
                        timer = periodJSON.val;
                        if(oscillatingJSON.val)
                        {
                            if(oscillationVariance.val<1)
                            {
                                oscillationVariance.val=1;
                            }
                            var oscillation_random_temp=Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val)/oscillationVariance.val;
                            if(oscillation)
                            {
                                
                                targetMagnitudeJSON.val=upperMagnitudeJSON.val-oscillation_random_temp;
                                oscillation=false;
                            }
                            else
                            {
                                targetMagnitudeJSON.val=lowerMagnitudeJSON.val+oscillation_random_temp;
                                oscillation=true;
                            }
                        }
                        else
                        {
                            targetMagnitudeJSON.val = Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
                        }
                    }
                    currentMagnitudeJSON.val = Mathf.Lerp(currentMagnitudeJSON.val, targetMagnitudeJSON.val, Time.deltaTime * quicknessJSON.val);
                }
            }
            else
            {
                currentMagnitudeJSON.val = windStrength.val;
            }

            //Wind Decay by distance
            if(isRadialIntensity)
            {
                var distanceFactor=personDirection.magnitude*personDirection.magnitude/100;
                var decayFactor=distanceFactor*windDecay.val*windStrength.val;
                currentMagnitudeJSON.val = currentMagnitudeJSON.val - decayFactor;
                if(currentMagnitudeJSON.val < 0)
                {currentMagnitudeJSON.val=0;}
            }

            //Add Wind direction turbulence
            setWindTurbulence();

            //Apply wind to clothes
            if (isGlobal)
            {
                foreach (string storableId in receivingAtom.GetStorableIDs())
				{
					SyncReceiver(storableId);

					foreach (string vector3ParamName in receiver.GetVector3ParamNames())
					{
                        updateClothHair(vector3ParamName);
					}
                    
                }
                
            }

            //Apply wind to rigidbodies
            if (isAvatar)
			{
                foreach(KeyValuePair<string,bool> RB_elem in RB_enabled)
                {
                    if(RB_elem.Value)
                    {
                        if(RB_elem.Key=="control")
                        {
                            updateController_control(RB_mobility[RB_elem.Key]);
                        }
                        else
                        {
                            updateController(RB_elem.Key, RB_mobility[RB_elem.Key]);
                        }
                    }
                }

			}
            //Sending currentmagnitude to selected slider

            receivingSlider.GetStorableByID("Trigger").GetFloatJSONParam("value").val=currentMagnitudeJSON.val/topSliderMagnitudeJSON.val;
        }

        protected void strengthByVelocity()
        {
            foreach (ForceReceiver fr in containingAtom.forceReceivers)
            {
                if(fr.name=="object")
                {
                    if(timer2<1)
                    {
                        timer2+=Time.deltaTime * speedQuickness.val;
                        windStrength.val=Mathf.Lerp(oldSpeed, speed, timer2);
                    }
                    else
                    {
                        var RBvelocity=0f;
                        var RBvelocityLin=0f;
                        var RBvelocityAng=0f;
                        oldSpeed=speed;
                        var RB = fr.GetComponent<Rigidbody>();
                        if(isByRotation)
                        {
                            RBvelocityAng=RB.angularVelocity.magnitude;
                        }
                        if(isBySpeed)
                        {
                            RBvelocityLin=RB.velocity.magnitude;
                        }
                        RBvelocity=RBvelocityLin+RBvelocityAng;
                        speed=(RBvelocity-speedThreshold.val)*speedMultiplier.val;
                        if(speed<0){speed=0;}
                        timer2=0f;
                    }
                }
            }
        }

        protected void updateController_control(JSONStorableFloat mobility)
        {
            var windRandomX=Random.Range(-windTurbulence.val, windTurbulence.val);
            var windRandomZ=Random.Range(-windTurbulence.val, windTurbulence.val);
            var frWindDirection=new Vector3(newDirection.x + windRandomX,0, newDirection.z + windRandomZ);
            var mobilityFactor=mobility.val*avatarMobility.val*10000;
            var forceValue=currentMagnitudeJSON.val;

            if(currentMagnitudeJSON.val==0)
            {
                receivingAtom.GetStorableByID("control").transform.position+=currentMagnitudeJSON.val * frWindDirection.normalized;
            }
            else
            {
                receivingAtom.GetStorableByID("control").transform.position+=(forceValue / mobilityFactor) * (frWindDirection.normalized);
            }
        }

        protected void updateClothHair(string vector3ParamName)
        {
            SyncReceiverTarget(vector3ParamName);
            var RandomPush=Random.Range(-currentMagnitudeJSON.val/4, currentMagnitudeJSON.val);
            var windRandomY=Random.Range(-windTurbulence.val/4, windTurbulence.val/4);
            var windRandomX=Random.Range(-windTurbulence.val/4, windTurbulence.val/4);
            var clothWindDirection=new Vector3(newDirection.x + windRandomX, newDirection.y + windRandomY, newDirection.z);
            if(currentMagnitudeJSON.val!=0)
            {
                receiverTarget.val = (currentMagnitudeJSON.val + RandomPush) * clothWindDirection.normalized;
            }
            else
            {
                receiverTarget.val = (currentMagnitudeJSON.val) * clothWindDirection.normalized;
            }
        }

        protected void updateController(string Controller, JSONStorableFloat mobility)
        {
            
            SyncReceiverRB(Controller);
            var temp_controller = new FreeControllerV3();
            if(!receivingAtom.GetStorableByID(Controller+"Control"))
            {}
            else if(pushAvatar)
            {
                temp_controller = receivingAtom.GetStorableByID(Controller+"Control") as FreeControllerV3;
            }    
            
            var RandomPush=Random.Range(-currentMagnitudeJSON.val/4, currentMagnitudeJSON.val);
            var windRandomY=Random.Range(-windTurbulence.val, windTurbulence.val);
            var windRandomX=Random.Range(-windTurbulence.val, windTurbulence.val);
            var windRandomZ=Random.Range(-windTurbulence.val, windTurbulence.val);
            var frWindDirection=new Vector3(newDirection.x + windRandomX, newDirection.y + windRandomY, newDirection.z + windRandomZ);
            var mobilityFactor=mobility.val*avatarMobility.val*10;
            var mobilityFactorController=mobility.val*avatarMobility.val*100000;
            var forceValue=currentMagnitudeJSON.val+RandomPush;

            if(mobilityFactor<1)
            {
                mobilityFactor=1;
            }
            if(currentMagnitudeJSON.val==0)
            {
                RB.AddForce(currentMagnitudeJSON.val * frWindDirection.normalized);
                if(!receivingAtom.GetStorableByID(Controller+"Control"))
                {}
                else if(pushAvatar)
                {
                    temp_controller.transform.position += currentMagnitudeJSON.val * frWindDirection.normalized;
                }
                
            }
            else
            {
                RB.AddForce((forceValue / mobilityFactor) * (frWindDirection.normalized));
                if(!receivingAtom.GetStorableByID(Controller+"Control"))
                {}
                else if(pushAvatar)
                {
                    temp_controller.transform.position += (forceValue / mobilityFactorController) * (frWindDirection.normalized);
                }
            }
        }

        protected void turnWindOff_Clothes()
        {
            foreach (string storableId in receivingAtom.GetStorableIDs())
            {
                SyncReceiver(storableId);

                foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                {
                    SyncReceiverTarget(vector3ParamName);
                    var clothWindDirection = new Vector3(0,-9.8f,0);
                    receiverTarget.val = clothWindDirection;
                }
                
            }
        }

        //Functions to color UI elements
        protected void color_slider(UIDynamicSlider slider, Color text,Color background)
        {
            var sliderBGImage = slider.GetComponentInChildren<Image>();
            sliderBGImage.color = background;
            slider.labelText.color=text;
        }

        protected void color_toggle(UIDynamicToggle toggle, Color text,Color background)
        {
            toggle.backgroundColor=background;
            toggle.textColor=text;
        }

        protected void color_btn(UIDynamicButton btn, Color text,Color background)
        {
            btn.buttonColor = background;
            btn.textColor = text;
        }

        protected void setControllerStateOff(string controller)
        {
            FreeControllerV3 headControl = receivingAtom.GetStorableByID(controller) as FreeControllerV3;
            headControl.currentPositionState=FreeControllerV3.PositionState.Off;
            headControl.currentRotationState=FreeControllerV3.RotationState.Off;
        }

        protected void setControllerStateComply(string controller)
        {
            FreeControllerV3 headControl = receivingAtom.GetStorableByID(controller) as FreeControllerV3;
            headControl.currentPositionState=FreeControllerV3.PositionState.Comply;
            headControl.currentRotationState=FreeControllerV3.RotationState.Comply;
        }

        protected void setWindTurbulence()
        {
            var windRandomY=Random.Range(-windTurbulence.val, windTurbulence.val);
            var windRandomX=Random.Range(-windTurbulence.val, windTurbulence.val);
            newDirection = new Vector3(newDirection.x + windRandomX, newDirection.y + windRandomY , newDirection.z).normalized;
        }

        protected void OnDestroy()
        {
            turnWindOff_Clothes();
            if (SuperController.singleton)
                SuperController.singleton.onAtomUIDRenameHandlers -= new SuperController.OnAtomUIDRename(OnAtomRename);
        }
    }

}
